d6086c1418210bd52c5005b5b051d66d497bc113
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # A yes/no parameter that controls whether to cross-build for an ARM host.
46 ARM_HOSTED_BUILD="$9"
47
48 # A yes/no parameter that controls whether to cross-build for the iOS simulator
49 IOS_SIM_BUILD="${10}"
50
51 # The version number of the submission, e.g. 1007.
52 LLVM_SUBMIT_VERSION="${11}"
53
54 # The subversion number of the submission, e.g. 03.
55 LLVM_SUBMIT_SUBVERSION="${12}"
56
57 # The current working directory is where the build will happen. It may already
58 # contain a partial result of an interrupted build, in which case this script
59 # will continue where it left off.
60 DIR=`pwd`
61
62 DARWIN_VERS=`uname -r | sed 's/\..*//'`
63 echo DARWIN_VERS = $DARWIN_VERS
64
65 ################################################################################
66 # Run the build.
67
68 # Create the source tree we'll actually use to build, deleting
69 # tcl since it doesn't actually build properly in a cross environment
70 # and we don't really need it.
71 SRC_DIR=$DIR/src
72 rm -rf $SRC_DIR || exit 1
73 mkdir $SRC_DIR || exit 1
74 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
75 # We can't use the top-level Makefile as-is.  Remove the soft link:
76 rm $SRC_DIR/Makefile || exit 1
77 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
78 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
79
80 # Build the LLVM tree universal.
81 mkdir -p $DIR/obj-llvm || exit 1
82 cd $DIR/obj-llvm || exit 1
83
84 if [ "$ARM_HOSTED_BUILD" = yes ]; then
85   # The cross-tools' build process expects to find an existing cross toolchain
86   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
87   rm -rf $DIR/bin || exit 1
88   mkdir $DIR/bin || exit 1
89   for prog in ar nm ranlib strip lipo ld as ; do
90     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
91     T=`xcrun -sdk $SDKROOT -find ${prog}`
92     echo '#!/bin/sh' > $P || exit 1
93     echo 'exec '$T' "$@"' >> $P || exit 1
94     chmod a+x $P || exit 1
95   done
96   # Set up the links for clang.
97   for prog in clang clang++ ; do
98     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
99     T=`xcrun -sdk $SDKROOT -find ${prog}`
100     echo '#!/bin/sh' > $P || exit 1
101     echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
102     chmod a+x $P || exit 1
103   done
104
105   PATH=$DIR/bin:$PATH
106 fi
107
108 if [ "$ARM_HOSTED_BUILD" = yes ]; then
109   configure_opts="--enable-targets=arm --host=arm-apple-darwin10 \
110                   --target=arm-apple-darwin10 --build=i686-apple-darwin10"
111 elif [ "$IOS_SIM_BUILD" = yes ]; then
112   # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
113   configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
114                   --build=i686-apple-darwin10"
115 else
116   configure_opts="--enable-targets=arm,x86"
117 fi
118
119 if [ "$ARM_HOSTED_BUILD" != yes ]; then
120   if [ $SDKROOT ]; then
121     CPPFLAGS="$CPPFLAGS -isysroot $SDKROOT"
122   fi
123   for host in $HOSTS; do
124     CPPFLAGS="$CPPFLAGS -arch $host"
125   done
126 fi
127
128 if [ \! -f Makefile.config ]; then
129   $SRC_DIR/configure --prefix=$DEST_DIR$DEST_ROOT $configure_opts \
130     --enable-assertions=$LLVM_ASSERTIONS \
131     --enable-optimized=$LLVM_OPTIMIZED \
132     --disable-bindings \
133     CPPFLAGS="$CPPFLAGS" \
134     || exit 1
135 fi
136
137 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
138
139 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
140     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
141     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
142     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
143 fi
144
145 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
146     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
147 else
148     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
149 fi
150
151 # Figure out how many make processes to run.
152 SYSCTL=`sysctl -n hw.activecpu`
153 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
154 # Builders can default to 2, since even if they are single processor,
155 # nothing else is running on the machine.
156 if [ -z "$SYSCTL" ]; then
157     SYSCTL=2
158 fi
159 JOBS_FLAG="-j $SYSCTL"
160
161 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
162     UNIVERSAL_SDK_PATH=$SDKROOT \
163     NO_RUNTIME_LIBS=1 \
164     DISABLE_EDIS=1 \
165     REQUIRES_RTTI=1 \
166     DEBUG_SYMBOLS=1 \
167     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
168     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
169     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
170     VERBOSE=1
171
172 if [ $? != 0 ] ; then
173     echo "error: LLVM 'make' failed!"
174     exit 1
175 fi 
176
177 ################################################################################
178 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
179 # $DEST_DIR, with occasional 'lipo' commands.
180
181 cd $DEST_DIR || exit 1
182
183 # Clean out DEST_DIR in case -noclean was passed to buildit.
184 rm -rf * || exit 1
185
186 cd $DIR/obj-llvm || exit 1
187
188 # Install the tree into the destination directory.
189 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
190     NO_RUNTIME_LIBS=1 \
191     DISABLE_EDIS=1 \
192     DEBUG_SYMBOLS=1 \
193     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
194     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
195     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
196
197 if ! test $? == 0 ; then
198     echo "error: LLVM 'make install' failed!"
199     exit 1
200 fi 
201
202 # Install Version.h
203 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
204 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
205     LLVM_MINOR_VERSION=0
206 fi
207 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
208 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
209 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
210
211 # Find the right version of strip to use.
212 STRIP=strip
213 if [ -n "$SDKROOT" ]; then
214   STRIP=`xcrun -sdk $SDKROOT -find strip`
215 fi
216
217 if [ "x$LLVM_DEBUG" != "x1" ]; then
218     # Strip local symbols from llvm libraries.
219     #
220     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
221     # PPC objects!
222     $STRIP -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
223     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
224         $STRIP -Sxl $f
225     done
226 fi
227
228 # Remove .dir files 
229 cd $DEST_DIR$DEST_ROOT
230 rm -f bin/.dir etc/llvm/.dir lib/.dir
231
232 # Remove PPC64 fat slices.
233 cd $DEST_DIR$DEST_ROOT/bin
234 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
235     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
236         -exec lipo -extract ppc -extract i386 {} -output {} \;
237 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
238     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
239         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
240 else
241     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
242         -exec lipo -extract i386 -extract x86_64 {} -output {} \;
243 fi
244
245 # The Hello dylib is an example of how to build a pass.
246 # The BugpointPasses module is only used to test bugpoint.
247 # These unversioned dylibs cause verification failures, so do not install them.
248 # (The wildcards are used to match a "lib" prefix if it is present.)
249 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
250 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
251
252 # Compress manpages
253 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
254 gzip -f $MDIR/*
255
256 ################################################################################
257 # Create SYM_DIR with information required for debugging.
258
259 # Figure out how many make processes to run.
260 SYSCTL=`sysctl -n hw.activecpu`
261
262 # hw.activecpu only available in 10.2.6 and later
263 if [ -z "$SYSCTL" ]; then
264   SYSCTL=`sysctl -n hw.ncpu`
265 fi
266
267 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
268 # can default to 2, since even if they are single processor, nothing else is
269 # running on the machine.
270 if [ -z "$SYSCTL" ]; then
271   SYSCTL=2
272 fi
273
274 cd $SYM_DIR || exit 1
275
276 # Clean out SYM_DIR in case -noclean was passed to buildit.
277 rm -rf * || exit 1
278
279 # Generate .dSYM files
280 find $DEST_DIR -perm -0111 -type f \
281     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
282     -print | xargs -n 1 -P ${SYSCTL} dsymutil
283
284 # Save .dSYM files and .a archives
285 cd $DEST_DIR || exit 1
286 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
287     | cpio -pdml $SYM_DIR || exit 1
288
289 # Save source files.
290 mkdir $SYM_DIR/src || exit 1
291 cd $DIR || exit 1
292 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
293     | cpio -pdml $SYM_DIR/src || exit 1
294
295 ################################################################################
296 # Remove libLTO.dylib and lto.h.  Those are installed by clang.
297
298 cd $DEST_DIR$DEST_ROOT
299 rm -f lib/libLTO.dylib
300 rm -f lib/libLTO.a lib/libLTO.la
301 find $DEST_DIR$DEST_ROOT -name lto.h -delete
302
303 ################################################################################
304 # Remove debugging information from DEST_DIR.
305
306 cd $DIR || exit 1
307
308 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
309 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
310
311 # Strip debugging information from files
312 #
313 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
314 # PPC objects!
315 find $DEST_DIR -perm -0111 -type f \
316     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
317     -print | xargs -n 1 -P ${SYSCTL} $STRIP -arch all -Sl
318
319 chgrp -h -R wheel $DEST_DIR
320 chgrp -R wheel $DEST_DIR
321
322 ################################################################################
323 # Remove the docs directory
324
325 rm -rf $DEST_DIR$DEST_ROOT/docs
326
327 ################################################################################
328 # w00t! Done!
329
330 exit 0